# Articles ![data_input](images/articles.png)

**[#1 - Build your own Low-Code Business Applications with SpiffWorkflow](https://medium.com/@danfunk/build-your-own-low-code-business-applications-with-spiffworkflow-1d0730acc1f3)**

This article introduces SpiffWorkflow as a low-code application development tool that utilizes flow-chart diagrams.
It emphasizes the involvement of clients in the architectural decision-making process and highlights the use of BPMN diagrams, user tasks, script tasks, and exclusive gateways.
The article concludes by showcasing a Python code example for loading and executing BPMN diagrams with SpiffWorkflow.

----

**[#2 - SpiffWorkflow, A New Hope](https://medium.com/@danfunk/spiffworkflow-a-new-hope-3f0c1dc72adb)**

SpiffWorkflow empowers non-coders to control app logic using flow-chart diagrams.
It emphasizes collaboration, integration, and future goals such as custom diagram tools and process management.
The article introduces components of the system and invites reader involvement.

----

**[#3 - Understanding BPMN’s Data Objects with SpiffWorkflow](https://medium.com/@danfunk/understanding-bpmns-data-objects-with-spiffworkflow-26e195e23398)**

This article explains BPMN Data Objects and their implementation in the SpiffWorkflow project.
It covers the default data flow behavior, the use of Data Objects for controlling data access, and the benefits of using them.
The article also mentions data transformations and the two types of data in SpiffWorkflow.
It concludes with information on upcoming releases and encourages reader involvement.

----

**[#4 - Understanding BPMN Messages](https://medium.com/@danfunk/understanding-bpmn-messages-7b0fee2d6a81)**

This article explores BPMN 2.0 Messages and their implementation in the SpiffWorkflow project.
It covers concepts like messages, collaborations, and correlations in BPMN diagrams.
The article discusses changes made to SpiffWorkflow applications to support message handling and communication between processes.
It emphasizes the importance of maintaining correlation consistency and highlights the benefits of enabling communication between complex systems.

----

**[#5 - Getting Started with SpiffArena](https://medium.com/@danfunk/getting-started-8ec59afe3a48)**

The article offers a tutorial on using SpiffArena to create and run executable SpiffWorkflow diagrams.
It covers installation, building a simple workflow process using BPMN diagrams and tasks, and concludes with shutting down the application.
The tutorial highlights the potential of SpiffWorkflow in enhancing transparency and collaboration in complex business processes.

----

**[#6 - The Low Code Wall](https://medium.com/@danfunk/the-low-code-wall-fa2e3476cc10)**

The article discusses low-code and no-code tools for software development, emphasizing the challenges and pitfalls that may arise.
It suggests considering open standards, collaboration with IT departments, and introduces SpiffArena as an open-source alternative that encourages collaboration and utilizes visual tools and familiar interfaces.

----

**[#7 - SpiffArena, the low-code visual workflow builder, awaits you like a clean canvas…](https://medium.com/@danfunk/spiffarena-the-low-code-visual-workflow-builder-awaits-you-like-a-clean-canvas-e7b9bd20ae71)**

SpiffArena is a browser-based tool that allows you to create flow-chart-like diagrams for automating business workflows.
It offers features such as form builders, application connections, timers, custom APIs, and robust permissions.
SpiffArena combines BPMN and Python to provide a powerful and configurable solution.

----

**[#8 - A Visual Workflow Library for Python](https://medium.com/@danfunk/a-visual-workflow-library-for-python-d19e1387653)**

SpiffWorkflow is a Python library that simplifies complex business logic by using BPMN diagrams, allowing non-developers to make changes to application flows.
It improves communication within teams, increases contributions, and adapts to changing requirements.
Visual software development environments like SpiffWorkflow represent the future of solving complex problems.
