# Welcome to SpiffWorkflow's documentation

```{toctree}
:maxdepth: 1
:caption: Getting Started
Getting_Started/quick_start.md
```

```{toctree}
:maxdepth: 1
:caption: Building Diagrams
Building_Diagrams/learn_basics.md
Building_Diagrams/bpmn.md
Building_Diagrams/Forms.md
Building_Diagrams/gateways.md
Building_Diagrams/events.md
Building_Diagrams/message_events.md
Building_Diagrams/signal_events.md
Building_Diagrams/timer_events.md
Building_Diagrams/escalation_events.md
Building_Diagrams/conditional_events.md
Building_Diagrams/error_events.md
Building_Diagrams/Displaying_Content.md
Building_Diagrams/Script_Tasks.md
Building_Diagrams/sub-processes_and_call_activities.md
Building_Diagrams/data.md
Building_Diagrams/multiinstance.md
Building_Diagrams/dmn.md
Building_Diagrams/Extensions.md
Building_Diagrams/pools_and_lanes.md
Building_Diagrams/Builtin_examples.md
```

```{toctree}
:maxdepth: 1
:caption: Debugging Diagrams
Debugging_Diagrams/bpmn_unit_tests.md
Debugging_Diagrams/process_error_handling.md
Debugging_Diagrams/Private_data.md
```

```{toctree}
:maxdepth: 1
:caption: DevOps - Installation & Integration
DevOps_installation_integration/admin_and_permissions.md
DevOps_installation_integration/permission_url.md
DevOps_installation_integration/configure_connector_proxy.md
DevOps_installation_integration/deploy_aws_lambda.md
DevOps_installation_integration/Secrets.md
DevOps_installation_integration/redis_celery_broker.md
DevOps_installation_integration/path_based_routing.md
DevOps_installation_integration/process_model_management.md
```

```{toctree}
:maxdepth: 1
:caption: Support & Administration
Support/suspend_resume_terminate.md
Support/Welcome_Messages.md
Support/Running_Server_Locally.md
Support/FAQ.md
```

```{toctree}
:maxdepth: 1
:caption: Appendices
appendices/glossary.md
appendices/articles.md
appendices/bpmn_terminology.md
documentation/documentation.md
wish_list/wish_list.md
```

## Indices and tables

- [](genindex)
- [](modindex)
- [](search)
